<?php
/**
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 * Category List Change Layout ver 1.1
 *
 * Plugin Written by Joe Carver - http://photos-by.joe-carver.com - http://gallery.josephcarver.com/natural/ - http://i-imagine.net/artists/
 * 29 March 2010
**/

	require_once('./plugins/catlist-page-layout/init.inc.php');

	if (!GALLERY_ADMIN_MODE) {
		cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
	}

	pageheader(sprintf($new_layout_lang['configure_plugin_x'], $new_layout_lang['display_name']));
	
    global $lang_plugin_php, $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array;

	list($timestamp, $form_token) = getFormToken();

	// get sanitized POST parameters
		if ($superCage->post->keyExists('submit')) {
		//Check if the form token is valid
		if(!checkFormToken()){
			cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
		}
	
  // Define the sanitization patterns
  $sanitization_array = array(
      'cat_zero_layout' => array('type' => 'array', 'regex_ok' => '/^[a-z]+$/', 'delimiter' => '/'),	
      'cat_nonzero_layout' => array('type' => 'array', 'regex_ok' => '/^[a-z]+$/', 'delimiter' => '/'),
      'cat_nonzero_select' => array('type' => 'checkbox', 'min' => '0', 'max' => '1')	  
	  );
	  $config_changes_counter = 0;
	  foreach ($sanitization_array as $san_key => $san_value) {
	          if ($san_value['type'] == 'array') { // type is array --- start              
          $evaluate_value = $superCage->post->getRaw($san_key);
              //print_r($superCage->post->getRaw($san_key));
              if (is_array($evaluate_value) && isset($san_value['regex_ok']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                  $temp = '';
                  for ($i = 0; $i <= count($evaluate_value); $i++) {
                      if (preg_match($san_value['regex_ok'], $evaluate_value[$i])) {
                          $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                      }
                  }
                  unset($evaluate_value);
                  $evaluate_value = rtrim($temp, $san_value['delimiter']);
                  unset($temp);
              }
              if ($evaluate_value != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $evaluate_value;
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is array --- end
          if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
            if ($superCage->post->getInt($san_key) == $san_value['max'] && $CONFIG[$san_key] != $san_value['max']) {
                $CONFIG[$san_key] = $san_value['max'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->getInt($san_key) == $san_value['min'] && $CONFIG[$san_key] != $san_value['min']) {
                $CONFIG[$san_key] = $san_value['min'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                $CONFIG[$san_key] = 0;
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            }
          } // type is checkbox --- end      
		} // only loop if config value is set --- end
	}

	// var for form display
	if ($CONFIG['cat_nonzero_select'] == '1') {
		$option_output['cat_nonzero_select'] = 'checked="checked"';
	} else { 
		$option_output['cat_nonzero_select'] = '';
	}

	// start form
	$superCage = Inspekt::makeSuperCage();
	echo <<< EOT
	<tr><td>
	<form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
EOT;
	
	starttable('100%',  sprintf($new_layout_lang['configure_plugin_x'], $new_layout_lang['display_name']), 2, 'cpg_zebra');	
	
	// reply with success to changes or no changes made
	if ($superCage->post->keyExists('submit')) {
    echo <<< EOT
	<tr>
		<td class="tableh2" colspan="2">
EOT;
    if ($config_changes_counter > 0) {
        msg_box('', $new_layout_lang['update_success'], '', '', 'success');
    } else {
        msg_box('', $new_layout_lang['no_changes'], '', '', 'validation');
    }
	echo <<< EOT
		</td>
	</tr>
EOT;
}

	// complete form
	echo <<< EOT
			<tr>
			<td><br><b>{$new_layout_lang['page_head']}</b></td>
			</tr>
			<tr>
            <td class="tableb">
			<hr>
			{$new_layout_lang['homepage_layout']}<a href="help.php?f=configuration.htm&as=admin_album_list_content&ae=admin_album_list_content_end"class="greybox" title="{$new_layout_lang['cpg_help']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>	
            <br />
			<br />
			{$CONFIG['main_page_layout']}
			</td>
            </tr>
            <tr>
            <td class="tableb">
			<hr>
			{$new_layout_lang['cat_zero_layout']}<a href="plugins/catlist-page-layout/docs/{$documentation_file}.htm#set_loc" class="greybox" title="{$new_layout_lang['update_help']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
			</td>
            <td>
			<br />
            <input type="text" size="50" maxlength="250" class="textinput" style="width:90%" name="cat_zero_layout" id="cat_zero_layout"  value="{$CONFIG['cat_zero_layout']}" />
            </td>
			</tr>
			<tr>
			<td class="tableb"> <hr> {$new_layout_lang['cat_nonzero_select']}
			<a href="plugins/catlist-page-layout/docs/{$documentation_file}.htm#select_non" class="greybox" title="{$new_layout_lang['update_help']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
			</td>			
			<td>
            <input type="checkbox" name="cat_nonzero_select" id="cat_nonzero_select" class="checkbox" value="1" {$option_output['cat_nonzero_select']} />
            <label for="cat_nonzero_select" class="clickable_option">{$lang_common['yes']}</label>
            </td>			
			</tr>			
			<tr>
            <td class="tableb">
			<hr>
			{$new_layout_lang['cat_nonzero_layout']}<a href="plugins/catlist-page-layout/docs/{$documentation_file}.htm#set_non" class="greybox" title="{$new_layout_lang['update_help']}"><img src="images/help.gif" width="13" height="11" border="0" alt="" /></a>
			</td>
            <td>
			<br />
            <input type="text" size="50" maxlength="250" class="textinput" style="width:90%" name="cat_nonzero_layout" id="cat_nonzero_layout"  value="{$CONFIG['cat_nonzero_layout']}" />
            </td>
			</tr>			
			<tr>			
	       <td class="tableb" align="right"><br /><br />
			<span>
			<input type="hidden" name="form_token" value="{$form_token}" />
    		<input type="hidden" name="timestamp" value="{$timestamp}" />
			<input type="submit" name="submit" value="{$new_layout_lang['submit_change']}" /> 
		</span>
		</td>
		</tr>
		</td>		
EOT;

	endtable();
	echo <<< EOT
	</form>
EOT;

	pagefooter();
	ob_end_flush();

?>